﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Windows.Forms
Imports WiimoteLib
Public Class Form1
    Private Delegate Sub UpdateWiimoteStateDelegate(ByVal args As WiimoteChangedEventArgs)
    Private waittimes As Integer = 30
    Private mkLange As Integer = 2
    Private wm As New Wiimote
    Private cx, cy, cz As Single

    Public Sub New()
        InitializeComponent()
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        wm.Connect()
        wm.SetReportType(InputReport.ButtonsAccel, True)
        wm.SetLEDs(False, True, True, False)
        AddHandler wm.WiimoteChanged, AddressOf wm_WiimoteChanged
        Button1.BackColor = Color.Pink
    End Sub
    Private Sub wm_WiimoteChanged(ByVal sender As Object, ByVal args As WiimoteChangedEventArgs)
        UpdateState(args)
    End Sub
    Public Sub UpdateState(ByVal args As WiimoteChangedEventArgs)
        System.Threading.Thread.Sleep(waittimes)
        BeginInvoke(New UpdateWiimoteStateDelegate(AddressOf UpdateWiimoteChanged), args)
    End Sub

    Private Sub UpdateWiimoteChanged(ByVal args As WiimoteChangedEventArgs)
        Dim ws As WiimoteState = args.WiimoteState
        Label4.Text = Int((98 * ws.AccelState.Values.X) - cx * 10 + 0.5) / 10
        Label5.Text = Int((98 * ws.AccelState.Values.Y) - cy * 10 + 0.5) / 10
        Label6.Text = Int((98 * ws.AccelState.Values.Z) - cz * 10 + 0.5) / 10
        OvalShape1.Top = 262 + 25 * (1 + mkLange) * Label6.Text / 9.8
        OvalShape1.Left = 362 + 25 * (1 + mkLange) * Label4.Text / 9.8
        OvalShape2.Top = 195 + 25 * (1 + mkLange) * Label5.Text / 9.8
        OvalShape2.Left = 138 + 25 * (1 + mkLange) * Label4.Text / 9.8

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles MyBase.FormClosing
        wm.SetLEDs(False, False, False, False)
        wm.Disconnect()
    End Sub

    Private Sub Label1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label1.Click
        Label4.ForeColor = Color.LightGray
    End Sub

    Private Sub Label4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label4.Click
        Label4.ForeColor = Color.Black
    End Sub
    Private Sub Label2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label2.Click
        Label5.ForeColor = Color.LightGray
    End Sub

    Private Sub Label5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label5.Click
        Label5.ForeColor = Color.Black
    End Sub
    Private Sub Label3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label3.Click
        Label6.ForeColor = Color.LightGray
    End Sub

    Private Sub Label6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label6.Click
        Label6.ForeColor = Color.Black
    End Sub

 
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        waittimes = ComboBox1.Text
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        mkLange = ComboBox2.Text
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Button4.BackColor = Color.Pink
        If CheckBox1.Checked = True Then
            cx = Label4.Text
        End If
        If CheckBox2.Checked = True Then
            cy = Label5.Text
        End If
        If CheckBox3.Checked = True Then
            cz = Label6.Text
        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        cx = 0
        cy = 0
        cz = 0
        Button4.BackColor = Color.Silver
    End Sub
End Class
